/*
 * Respostas:
 * 
 * 1 - Não é possível mudar diretamente, pois o atributo tem o modificador private, que impede que este seja modificado
 * 	fora da classe.
 * 
 * 2 - O atributo poderia ser declarado com o modificador public. A vantagem seria utilizar o atributo diretamente, sem
 * 	nenhuma verbosidade associada com o uso de getters e setters. O problema é que isso aumenta o acoplamento entre as
 * 	classes, e faz com que modificações indesejadas possam ser feitas (atribuir um valor nulo para um objeto, por
 * 	exemplo, que causaria uma exceção futuramente). O conceito quebrado seria o de encapsulamento.
 */

package inicio;

import perfil.Perfil;
import usuario.Usuario;

public class Lab1 {

	public static void main(String[] args) {
		Usuario usuario1 = new Usuario(1, "Joanna");
		Usuario usuario2 = new Usuario(2, "Owen");
		
		Perfil perfil1 = new Perfil('f', "01/01/1990", "Campinas", "SP", "555555555", true, 5);
		Perfil perfil2 = new Perfil('m', "02/02/1991", "Sao Paulo", "SP", "555555555", false, 2);
		
		System.out.println(usuario1);
		System.out.println(usuario2);
		System.out.println(perfil1);
		System.out.println(perfil2);	

	}

}
