/*
 * Respostas:
 * 
 * 1 - Vários benefícios. Um deles é que semânticamente pode fazer muito sentido ter herança pra representar algo
 *  que se comporta como herança em outro domínio (no mundo real, por exemplo). Por sua vez, isso costuma fazer
 *  com que haja reaproveitamento de código, o que é bom não somente para escrever menos, mas para que nào seja
 *  necessário fazer modificações em várias partes do código ao mesmo tempo.
 *  
 * 2 - Não é possível adicionar o modificador final no Grupo. Isso ocorre porque classes extendem de grupo, e o
 *  modificador final diz que nenhuma classe pode herdar dela. Pelo mesmo motivo, é possível adicionar final em
 *  GrupoPublico
 *  
 * 3 -
 *  a - Foi chamado o testStatic da classe Grupo, GrupoPublico e GrupoPublico respectivamente
 * 
 * 	b - Foi chamado o testNotStatic da classe GrupoPublico em todos os casos.
 *   O resultado não é o mesmo. O que acontece é que quando uma variável do tipo Grupo recebe uma referência
 *   de um objeto do tipo GrupoPublico, o método ou atributo que será acessado quando a chamada é para algo com
 *   modificador static, é o da classe que a variável foi declarada. Mas quando o atributo/método acessado não é
 *   static, então será acessado o do objeto. Isso é um pouco confuso, realmente, mas uma forma de entender é 
 *   pensar que quando algo static é acessado, não importa o objeto que está em baixo, e sim a classe da variável.
 */

package inicio;

import carona.Carona;
import caronante.Caronante;
import caroneiro.Caroneiro;
import grupo.Grupo;
import grupo.GrupoPrivado;
import grupo.GrupoPublico;
import perfil.Perfil;
import usuario.Usuario;

public class Lab4 {

	public static void main(String[] args) {
		Caronante caronante = new Caronante(5, "Chamber pop", "abcd-123", "abdef12345",
				"Alguma marca", "Algum modelo", 3);
		Caroneiro caroneiro1 = new Caroneiro(true);
		Caroneiro caroneiro2 = new Caroneiro(false);
		Caroneiro caroneiro3 = new Caroneiro("5435345345");
		
		Perfil perfilCaronante = new Perfil('f',"01/01/2001", "Campinas", "SP", "123123", true, caronante, null, null);		
		Usuario usuario1 = new Usuario("Joanna", "jnewsom@dunno.com", "sadie", true, perfilCaronante);
		perfilCaronante.setUsuario(usuario1);
		
		Perfil perfilCaroneiro1 = new Perfil('m',"01/01/1999", "Sorocaba", "SP", "123123", true, null, caroneiro1, null);		
		Usuario usuario2 = new Usuario("Sufjan", "sufjan@dunno.com", "wasps", true, perfilCaroneiro1);
		perfilCaroneiro1.setUsuario(usuario2);
		
		Perfil perfilCaroneiro2 = new Perfil('m',"01/01/1990", "Sao Paulo", "SP", "123123", true, null, caroneiro2, null);		
		Usuario usuario3 = new Usuario("Shinji", "hikari@dunno.com", "something", true, perfilCaroneiro2);
		perfilCaroneiro2.setUsuario(usuario3);
		
		Perfil perfilCaroneiro3 = new Perfil('f',"01/01/1999", "Belo Horizonte", "MG", "123123", true, null, caroneiro3, null);		
		Usuario usuario4 = new Usuario("Lily Briscoe", "lily@dunno.com", "ramsay", true, perfilCaroneiro3);
		perfilCaroneiro3.setUsuario(usuario4);
		
		Grupo grupo = new Grupo("Musicos", "Alguma descricao");
		usuario1.adicionarGrupo(grupo);
		usuario2.adicionarGrupo(grupo);
		
		GrupoPrivado grupoPrivado = new GrupoPrivado("Pilotos de robos", "Hm");
		usuario3.adicionarGrupo(grupoPrivado);
		
		GrupoPublico grupoPublico = new GrupoPublico("Pintores", "Alguem?");
		usuario4.adicionarGrupo(grupoPublico);
		
		//Verifica funcionamento do método
		Carona carona = caronante.oferecerCarona(13.2, 15.46, 13.45, 15.23, "15:05:00 10/10/2018");
		
		carona.adicionarCaroneiro(caroneiro1);
		carona.adicionarCaroneiro(caroneiro2);		
		carona.adicionarCaroneiro(caroneiro3);		
		
		//Testando mesma coisa, verificando se imprime os relacionamentos corretamente
		System.out.println("Imprimindo uma carona com 3 membros");
		System.out.println(carona);
		System.out.println("\n------------------\n");
		System.out.println("Imprimindo um grupo com 2 membros");
		System.out.println(grupo.toStringMostraMembros(0));
		System.out.println("\n------------------\n");
		System.out.println("Imprimindo um grupo privado com 1 membro");
		System.out.println(grupoPrivado.toStringMostraMembros(0));
		System.out.println("\n------------------\n");
		System.out.println("Imprimindo um grupo privado com 1 membro");
		System.out.println(grupoPublico.toStringMostraMembros(0));
		
		
		//Verifica se a variável estática foi corretamente modificada
		//Não vou chamar ela diretamente aqui (private e tal), mas o uso pode ser verificado nos construtores
		assert usuario4.getId() == 3;
		assert grupo.getId() == 0;
		assert grupoPublico.getId() == 2; //O Id é compartilhado, talvez não seja uma boa ideia em um sistema real
		
		//Teste com static
		System.out.println("\n------------------\n");
		System.out.println("Teste com variaveis static");
		Grupo a = new Grupo(null, null);
		GrupoPublico b = new GrupoPublico(null, null);
		GrupoPublico c = new GrupoPublico(null, null);
		a = b;
		b = c;
		System.out.println("testStatic de a: " + a.testStatic);
		System.out.println("testStatic de b: " + b.testStatic);
		System.out.println("testStatic de c: " + c.testStatic);
		System.out.println("testNotStatic de a: " + a.getTestNotStatic());
		System.out.println("testNotStatic de b: " + b.getTestNotStatic());
		System.out.println("testNotStatic de c: " + c.getTestNotStatic());
		
		
	}

}
