/*
 * Respostas:
 * 
 * 1 - Um enumerate public é visto de qualquer lugar, já um sem modificador é visto somente no pacote. Um private seria
 *  visto somente se estivesse declarado dentro de outra classe, por exemplo.
 *  
 * 2 - Enums são úteis para armazenar um valor dentre um determinado conjunto finito. Com o uso de enums não é mais
 *  necessário comparar strings, o que não só é custoso, mas é extremamente suscetível a erros de comparação e digitação.
 *  Enum serve como uma checagem mais forte, facilitando a programação e evitando erros.
 */

package inicio;

import carona.Carona;
import caronante.Caronante;
import caroneiro.Caroneiro;
import grupo.Grupo;
import grupo.GrupoPrivado;
import grupo.GrupoPublico;
import pagamento.MetodoPagamento;
import perfil.Perfil;
import usuario.Usuario;

public class Lab5 {

	public static void main(String[] args) {
		Caronante caronante = new Caronante(5, "Chamber pop", "abcd-123", "abdef12345",
				"Alguma marca", "Algum modelo", 3);
		Caroneiro caroneiro1 = new Caroneiro(true);
		Caroneiro caroneiro2 = new Caroneiro(false);
		Caroneiro caroneiro3 = new Caroneiro("5435345345");
		
		Perfil perfilCaronante = new Perfil('f',"01/01/2001", "Campinas", "SP", "123123", true, caronante, null, null);		
		Usuario usuario1 = new Usuario("Joanna", "jnewsom@dunno.com", "sadie", true, perfilCaronante);
		perfilCaronante.setUsuario(usuario1);
		
		Perfil perfilCaroneiro1 = new Perfil('m',"01/01/1999", "Sorocaba", "SP", "123123", true, null, caroneiro1, null);		
		Usuario usuario2 = new Usuario("Sufjan", "sufjan@dunno.com", "wasps", true, perfilCaroneiro1);
		perfilCaroneiro1.setUsuario(usuario2);
		
		Perfil perfilCaroneiro2 = new Perfil('m',"01/01/1990", "Sao Paulo", "SP", "123123", true, null, caroneiro2, null);		
		Usuario usuario3 = new Usuario("Shinji", "hikari@dunno.com", "something", true, perfilCaroneiro2);
		perfilCaroneiro2.setUsuario(usuario3);
		
		Perfil perfilCaroneiro3 = new Perfil('f',"01/01/1999", "Belo Horizonte", "MG", "123123", true, null, caroneiro3, null);		
		Usuario usuario4 = new Usuario("Lily Briscoe", "lily@dunno.com", "ramsay", true, perfilCaroneiro3);
		perfilCaroneiro3.setUsuario(usuario4);
		
		Grupo grupo = new Grupo("Musicos", "Alguma descricao");
		usuario1.adicionarGrupo(grupo);
		usuario2.adicionarGrupo(grupo);
		
		GrupoPrivado grupoPrivado = new GrupoPrivado("Pilotos de robos", "Hm");
		usuario3.adicionarGrupo(grupoPrivado);
		
		GrupoPublico grupoPublico = new GrupoPublico("Pintores", "Alguem?");
		usuario4.adicionarGrupo(grupoPublico);
		
		//Verifica funcionamento do método
		Carona carona = caronante.oferecerCarona(13.2, 15.46, 13.45, 15.23, "15:05:00 10/10/2018", 20.50f);
		
		carona.adicionarCaroneiro(caroneiro1);
		carona.adicionarCaroneiro(caroneiro2);		
		carona.adicionarCaroneiro(caroneiro3);		
		
		System.out.println("Adicionando CartaoDeCredito: " 
				+ carona.adicionarFormaPagamento(MetodoPagamento.CartaoDeCredito));
		System.out.println("Adicionando Dinheiro: " 
				+ carona.adicionarFormaPagamento(MetodoPagamento.Dinheiro));
		System.out.println("Carona gratuita? " 
				+ carona.caronaGratuita());
		assert carona.caronaGratuita() == false;
		System.out.println("Aceita dinheiro? " 
				+ carona.checarExistenciaFormaPagamento(MetodoPagamento.Dinheiro));
		assert carona.checarExistenciaFormaPagamento(MetodoPagamento.Dinheiro) == true;
		System.out.println("Removendo Dinheiro: " 
				+ carona.removerFormaPagamento(MetodoPagamento.Dinheiro));
		System.out.println("Adicionando Gratis: " 
				+ carona.adicionarFormaPagamento(MetodoPagamento.Gratis));
		System.out.println("Aceita dinheiro? " 
				+ carona.checarExistenciaFormaPagamento(MetodoPagamento.Dinheiro));
		assert carona.checarExistenciaFormaPagamento(MetodoPagamento.Dinheiro) == false;
		System.out.println("Carona gratuita? " 
				+ carona.caronaGratuita());
		assert carona.caronaGratuita() == true;
		
		System.out.println(carona);
		
	}

}
